]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- show statistics when compressing kernel modules
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # Build system path macros.
12 #
13 %__autoconf             autoconf %{?debug:-Wall}
14 %__automake             automake -a -c -f --foreign
15 %__autopoint            autopoint --force
16
17 %__gettextize { \
18 if ! gettextize --version | grep -q '0\.10\.' ; then \
19         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
20                 gettextize --copy --force --no-changelog; \
21         else \
22                 gettextize --copy --force --no-changelog --intl; \
23         fi; \
24         if [ ! -f po/Makevars ]; then \
25                 cp -f po/Makevars{.template,}; \
26         fi; \
27 else \
28         gettextize --copy --force; \
29 fi; \
30 }
31
32 %__glib_gettextize      glib-gettextize --copy --force
33 %__gnome_doc_common     gnome-doc-common --copy
34 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
35 %__gtkdocize            gtkdocize --copy
36 %__intltoolize          intltoolize --copy --force
37 %__libtoolize           libtoolize --copy --force
38
39 #       The number of cvs changelog entries kept when building package.
40 %_buildchangelogtruncate 20
41
42 %dependencytracking     %{nil}
43
44 #       Relations between package names that cause dependency loops
45 #       with legacy packages that cannot be fixed. Relations are
46 #       specified as
47 #               p>q
48 #       where package p has a Requires: on something that package q Provides:
49 #
50 # XXX   Note: that there cannot be any whitespace within the string "p>q",
51 #       and that both p and q are package names (i.e. no version/release).
52 %_dependency_whiteout   %{nil}
53
54
55 #-----------------------------------------------------------------
56 #
57 # (re)definition of %{rpm*flags} with %filterout_* support
58 # Requires:             awk
59 #
60 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
61 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
62 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
63 # %rpmldflags   = %optldflags - %filterout_ld
64 #
65 # Regular expressions are supported, but to avoid some character be treated
66 # as regular expression it must be escaped twice.
67
68 %filter_out                                             \
69         for (i in I) {  A=0;                    \
70                 for (f in F) {                          \
71                         if (I[i] ~ "^" F[f] "$") A=1;   \
72                 };                                                      \
73                 if (!A) printf(I[i] FS);        \
74         }
75
76 %rpmcflags %(awk 'BEGIN {
77         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
78         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
79         %{filter_out}
80 }')
81
82 %rpmcxxflags %(awk 'BEGIN {
83         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
84         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
85         %{filter_out}
86 }')
87
88 %rpmldflags %(awk 'BEGIN {
89         split("%{?optldflags}",I);
90         split("%{?filterout_ld}",F)
91         %{filter_out}
92 }')
93
94 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
95 # but, don't use it, better use gcc as linker
96 %ld_rpmldflags %(awk 'BEGIN {
97         split("%{rpmldflags}",F);
98         for (f in F) {
99                 s = F[f];
100                 if (s ~ /^-Wl,/) {
101                         s = substr(s,5);
102                         gsub(/,/," ",s);
103                 };
104                 printf(s FS);
105         };
106 }')
107
108 #-----------------------------------------------------------------
109 %configure2_13 { \
110  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
111  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
112  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
113  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
114  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
115  CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
116  %{?__cc:CC="%{__cc}" ; export CC ; } \
117  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
118  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
119         --host=%{_target_platform} \
120         --prefix=%{_prefix} \
121         --exec-prefix=%{_exec_prefix} \
122         --bindir=%{_bindir} \
123         --sbindir=%{_sbindir} \
124         --sysconfdir=%{_sysconfdir} \
125         --datadir=%{_datadir} \
126         --includedir=%{_includedir} \
127         --libdir=%{_libdir} \
128         --libexecdir=%{_libexecdir} \
129         --localstatedir=%{_localstatedir} \
130         --sharedstatedir=%{_sharedstatedir} \
131         --mandir=%{_mandir} \
132         --infodir=%{_infodir} \
133         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
134         %{dependencytracking} \
135 }
136
137 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
138 %__cmake        /usr/bin/cmake
139 %cmake { \
140 CC="%{__cc}" \
141 CXX="%{__cxx}" \
142 CFLAGS="%{rpmcflags}" \
143 CXXFLAGS="%{rpmcxxflags}" \
144 %{__cmake} \
145 }
146
147 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
148 %__scons        /usr/bin/scons
149 %scons { \
150 %{__scons} \
151 }
152
153 # waf. see waf.spec
154 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
155 %__waf  /usr/bin/waf
156 %waf { \
157 CC="%{__cc}" \
158 CXX="%{__cxx}" \
159 CPP="%{__cpp}" \
160 CFLAGS="%{rpmcflags}" \
161 CXXFLAGS="%{rpmcxxflags}" \
162 %{__waf} \
163 }
164
165 #----------------------------------------------------------------
166 %global configure_cache 0
167 %configure_cache_file   %{buildroot}.configure.cache
168
169 %configure {./configure \
170         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
171         CFLAGS="${CFLAGS:-%rpmcflags}" \
172         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
173         FFLAGS="${FFLAGS:-%rpmcflags}" \
174         CPPFLAGS="${CPPFLAGS:-}" \
175         %{?__cc:CC="%{__cc}"} \
176         %{?__cxx:CXX="%{__cxx}"} \
177         --host=%{_target_platform} \
178         --build=%{_target_platform} \
179         --prefix=%{_prefix} \
180         --exec-prefix=%{_exec_prefix} \
181         --bindir=%{_bindir} \
182         --sbindir=%{_sbindir} \
183         --sysconfdir=%{_sysconfdir} \
184         --datadir=%{_datadir} \
185         --includedir=%{_includedir} \
186         --libdir=%{_libdir} \
187         --libexecdir=%{_libexecdir} \
188         --localstatedir=%{_localstatedir} \
189         --sharedstatedir=%{_sharedstatedir} \
190         --mandir=%{_mandir} \
191         --infodir=%{_infodir} \
192         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
193         %{dependencytracking} \
194         %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
195 }
196
197 # ------------------------------------------------------------------------
198 # Overloading of some basic macros
199 %prep \
200 %%prep\
201 LANG=C\
202 export LANG\
203 unset DISPLAY ||:\
204 unset LINGUAS ||:\
205 %{nil}
206
207 %build %%build\
208 LANG=C\
209 export LANG\
210 unset DISPLAY ||:\
211 unset LINGUAS ||:\
212 %{nil}
213
214 %install \
215 %if 0%{?_enable_debug_packages}\
216 %{?buildsubdir:%{debug_package}}\
217 %endif\
218 %%install\
219 LANG=C\
220 export LANG\
221 unset DISPLAY ||:\
222 unset LINGUAS ||:\
223 %{nil}
224
225 # Location of autoconf macros
226 %_aclocaldir    %(aclocal --print-ac-dir)
227
228 # Location of omf files
229 %_omf_dest_dir  %(scrollkeeper-config --omfdir)
230
231 # Location of pkgconfig files
232 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
233
234 # Location of desktop files
235 %_desktopdir    /usr/share/applications
236 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
237
238 # Location of pixmaps for applnk/desktop files
239 %_pixmapsdir    /usr/share/pixmaps
240
241 # Location of themable icons for applnk/desktop files
242 %_iconsdir      /usr/share/icons
243
244 # Location of fonts directories
245 %_fontsdir      /usr/share/fonts
246
247 # Location of Gtk and associated libraries documentation
248 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
249
250 # Location of KDE documentation
251 %_kdedocdir     %{_defaultdocdir}/kde/HTML
252
253 # unsermake script
254 %__unsermake /usr/share/unsermake/unsermake
255
256 # Current date
257 %date           %(LC_ALL="C" date +"%a %b %d %Y")
258
259 # tmp directory
260 %tmpdir         %(echo "${TMPDIR:-/tmp}")
261
262 # Example files, programs, scripts...
263 %_examplesdir   /usr/src/examples
264
265 # Alternative kernel type/version
266 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
267
268 # The directory holding Linux kernel sources
269 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
270
271 # If non-empty "debug" macro defined, add "dbg" suffix to release number
272 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
273
274 # Requires name = version-release
275 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
276
277 %releq_kernel_up()              %((LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
278 %releq_kernel_smp()             %((LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h 2>/dev/null || echo ERROR) | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
279 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
280 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
281
282 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
283 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
284
285 %apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
286
287 # kernel version-release handling
288 %__kernel_ver   %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
289 %__kernel_rel   %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
290 %__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
291 %_kernel_ver    %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
292 %_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
293
294 # sgml macros
295 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
296 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
297 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
298 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
299 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
300 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
301 %docbook_sgmlcat_fix() { for l in \
302 '' \
303 '  -- default decl --' \
304 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
305 '  -- hacks for opensp --' \
306 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
307 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
308 '' \
309 ; do echo $l; done >> %1 \
310 }
311
312 # minimum file size needed for compressed documents.
313 # just smaller files than this get larger when compressed.
314 # some stats:
315 # - 0 byte file compressed was 25 bytes .gz
316 # - 39 byte file was compressed as 57
317 # - with test/test.spec@man 158 byte file was compressed also 158
318 %_min_compress_bytes    159
319
320 #-----------------------------------------------------------------
321 # find and gzip all files in %{_mandir} and %{infodir}
322 #
323 # Requires: xargs, find
324 #
325 #%no_install_post_compress_docs 1
326 %__spec_install_post_compress_docs { \
327 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
328         echo "Compress man and info pages."; \
329         for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
330                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
331                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
332                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
333                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
334                 fi; \
335         done; \
336 }; __spec_install_post_compress_docs } }
337
338 #-----------------------------------------------------------------
339 # Strip executable binaries and shared object files
340 #
341 # Requires: find, awk, strip, cut, xargs
342 #
343 #%no_install_post_strip 1
344 %__spec_install_post_strip {%{!?debug: \
345 %{!?no_install_post_strip:__spec_install_post_strip() { \
346         if [ -d "$RPM_BUILD_ROOT" ]; then \
347         echo "Strip executable binaries, archives and shared object files."; \
348         filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
349         elfexelist=`echo $filelist | xargs -r file | \
350                 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
351         elfsharedlist=`echo $filelist | xargs -r file | \
352                 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
353         elfarchiveslist=`echo $filelist | xargs -r file | \
354                 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
355         if [ -n "$elfexelist" ]; then \
356                 chmod u+w $elfexelist; \
357                 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
358         fi; \
359         if [ -n "$elfsharedlist" ]; then \
360                 chmod u+w $elfsharedlist; \
361                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
362         fi; \
363         if [ -n "$elfarchiveslist" ]; then \
364                 chmod u+w $elfarchiveslist; \
365                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
366         fi; \
367 fi; }; __spec_install_post_strip } } }
368
369 #-----------------------------------------------------------------
370 # remove all RPATH from executable binaries and shared object files
371 #
372 # Requires: find, awk, cut, xargs, chrpath, uname
373 #
374 #%no_install_post_chrpath       1
375 %__spec_install_post_chrpath {%{!?debug: \
376 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
377 if [ -d "$RPM_BUILD_ROOT" ]; then \
378 echo "Remove RPATH from executable binaries and shared object files."; \
379 find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
380         awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
381 while read file ; do \
382         rpath= ; \
383         chmod u+w "$file"; \
384         for dir in `chrpath -l "$file" | \
385                         awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
386                         case $dir in \
387                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
388                                 echo "remove-rpath: $dir in $file"; \
389                                 ;; \
390                         * ) \
391                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
392                                 else rpath="$rpath:$dir" ; fi ; \
393                                 ;; \
394                         esac ; \
395         done ; \
396         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
397         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
398 done; \
399 fi; }; __spec_install_post_chrpath } } }
400
401 #-----------------------------------------------------------------
402 # Find and gzip all kernel modules
403 #
404 # Requires: find
405 #
406 #%no_install_post_compress_modules      1
407 %__spec_install_post_compress_modules { \
408 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
409         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
410                 echo "Compress kernel modules"; \
411                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
412                 echo "$q" | xargs -r %{__gzip} -9nf; \
413                 printf "%d modules compressed\n" $(echo "$q" | wc -l); \
414                 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
415                 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
416         fi; \
417 }; __spec_install_post_compress_modules } }
418
419 # Remove common Perl files we don't package
420 %__spec_install_post_perl_clean {\
421 %{!?no_install_post_perl_clean: \
422 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
423 } }
424
425 #-----------------------------------------------------------------
426 # Update GConf2 schemas
427 #
428 # Requires: GConf2
429 #
430 %gconf_schema_install() \
431         umask 022; \
432         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
433         %{nil}
434
435 %gconf_schema_uninstall() \
436 if [ $1 = 0 ]; then \
437         umask 022; \
438         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
439 fi \
440 %{nil}
441
442 #-----------------------------------------------------------------
443 # Update desktop MIME database
444 # requires: desktop-file-utils
445 #
446 %update_desktop_database_post() {{ \
447         umask 022; \
448         /usr/bin/update-desktop-database -q; \
449 }}
450
451 %update_desktop_database_postun() {{ \
452 if [ $1 = 0 ]; then \
453         umask 022; \
454         /usr/bin/update-desktop-database -q; \
455 fi \
456 }}
457
458 #-----------------------------------------------------------------
459 # Update shared MIME info database
460 # requires: shared-mime-info
461 #
462 %update_mime_database() {{ \
463         umask 022; \
464         /usr/bin/update-mime-database %{_datadir}/mime; \
465 }}
466
467 #-----------------------------------------------------------------
468 # Update icon cache
469 # requires: gtk+
470 #
471 %update_icon_cache() {{ \
472         umask 022; \
473         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
474 }}
475
476 #-----------------------------------------------------------------
477 # Update scrollkeeper database
478 # requires: scrollkeeper
479 #
480 %scrollkeeper_update_post() \
481         /usr/bin/scrollkeeper-update -q; \
482         %{nil}
483
484 %scrollkeeper_update_postun() \
485 if [ $1 = 0 ]; then \
486         /usr/bin/scrollkeeper-update -q; \
487 fi \
488 %{nil}
489
490 #-----------------------------------------------------------------
491 # post %install sequence:
492 # - autodeps exceptions
493 # - compress all man and info pages,
494 # - strip all ELF executables and ELF shared objects if not %debug.
495 # - compress kernel modules if any
496
497 ###################################################################
498 # Requires/Provides automation
499 # exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
500 #
501 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
502 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
503 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
504 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
505 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
506 #%_noautocompressdoc    %{nil}
507 #
508 %_missing_doc_files_terminate_build     1%{nil}
509 %_unpackaged_files_terminate_build      %{nil}
510 # (X)emacs support
511 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
512 %_emacs_lispdir %(emacs %___emacs_lispdir_helper)
513 %_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
514
515 %__php_provides %{nil}
516 %__php_requires %{nil}
517 %__perl_provides %{nil}
518 %__perl_requires %{nil}
519 %__mono_provides %{nil}
520 %__mono_requires %{nil}
521
522 # Perl specific macro definitions.
523 %perl_privlib           %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
524 %perl_archlib           %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
525 %perl_vendorlib         %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
526 %perl_vendorarch        %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
527 %perl_sitelib           %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
528 %perl_sitearch          %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
529
530 # Ruby
531 %ruby_archdir           %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
532 %ruby_ridir                     %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
533 %ruby_rubylibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
534 %ruby_sitearchdir       %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
535 %ruby_sitelibdir        %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
536 %ruby_version           %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
537 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
538 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
539
540 %php_pear_dir           /usr/share/pear
541
542 # directory where php includes are installed on system.
543 %__php_includedir               /usr/include/php
544 # extract php/zend api versions
545 %php_major_version              %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
546 %php_api_version                %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
547 %php_pdo_api_version    %(awk '/#define PDO_DRIVER_API/{print $3}' %{__php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
548 %php_debug                              %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
549 %zend_module_api                %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
550 %zend_extension_api             %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
551 %zend_zts                               %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
552
553 # helper macro
554 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
555
556 # macros for public use
557 # for php extensions (php-pecl)
558 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
559 %{__php_api_requires zend_module_api} \
560 %{__php_api_requires -v %php_major_version debug php_debug} \
561 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
562
563 # for zend extensions
564 %requires_zend_extension %{__php_api_requires zend_module_api} \
565 %{__php_api_requires zend_extension_api} \
566 %{__php_api_requires -v %php_major_version debug php_debug} \
567 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
568
569 # for php pdo modules (php-pecl-PDO_*)
570 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
571
572 # Python specific macro definitions.
573 # python main version
574 %py_ver                 %(python -c "import sys; print sys.version[:3]")
575
576 # directories
577 %py_prefix              %(python -c "import sys; print sys.prefix")
578 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
579 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
580 %py_incdir              /usr/include/python%{py_ver}
581 %py_sitedir             %{py_libdir}/site-packages
582 %py_sitescriptdir %{py_scriptdir}/site-packages
583 %py_dyndir              %{py_libdir}/lib-dynload
584
585 # pure python modules compilation
586 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
587
588 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
589
590 # Software written in Python language require Python with main version
591 %pyrequires_eq() Requires:      %1
592
593 # Hardlink binary identical .pyc and .pyo files
594 # (idea by glen <at> pld-linux <dot> org)
595 %__spec_install_post_py_hardlink {\
596 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
597 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
598         b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
599         if cmp -s "$a" "$b"; then \
600                 ln -f "$a" "$b"; \
601         fi; \
602 done \
603 }; __spec_install_post_py_hardlink } }
604
605 # remove python sources, so that check-files won't complain
606 # (idea by glen <at> pld-linux <dot> org)
607 %py_postclean() \
608 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
609  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
610 done \
611 %{nil}
612
613 # depmod macro
614 %depmod() { \
615 umask 022; \
616 if [ -e /boot/System.map-%1 ]; then \
617         /sbin/depmod -a -F /boot/System.map-%1 %1; \
618 else \
619         if [ -e /boot/System.map ]; then \
620                 /sbin/depmod -a -F /boot/System.map %1; \
621         else \
622                 /sbin/depmod -a %1; \
623         fi \
624 fi; \
625 }
626
627 # XMMS specific macros
628 %xmms_prefix                    %(xmms-config --prefix 2>/dev/null)
629 %xmms_exec_prefix               %(xmms-config --exec-prefix 2>/dev/null)
630 %xmms_version                   %(xmms-config --version 2>/dev/null)
631 %xmms_datadir                   %(xmms-config --data-dir 2>/dev/null)
632 %xmms_plugindir                 %(xmms-config --plugin-dir 2>/dev/null)
633 %xmms_visualization_plugindir   %(xmms-config --visualization-plugin-dir 2>/dev/null)
634 %xmms_input_plugindir           %(xmms-config --input-plugin-dir 2>/dev/null)
635 %xmms_output_plugindir          %(xmms-config --output-plugin-dir 2>/dev/null)
636 %xmms_effect_plugindir          %(xmms-config --effect-plugin-dir 2>/dev/null)
637 %xmms_general_plugindir         %(xmms-config --general-plugin-dir 2>/dev/null)
638
639 %_target_base_arch      %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
640
641 # user/group checking macros
642 #
643 # Usage:
644 #       %userremove myuser
645 #
646 %userremove     /usr/lib/rpm/user_group.sh user del
647 %groupremove    /usr/lib/rpm/user_group.sh group del
648 #
649 # Usage:
650 #       if %usertestrm myuser; then
651 #               /usr/sbin/userdel -r myuser
652 # Note:
653 #       use these macros only if you need to call userdel/groupdel with
654 #       a non-standard option or take an extra action; otherwise use the
655 #       %userremove/%groupremove macros
656 #
657 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
658 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
659 # user group membership management macros
660 #
661 # Usage:
662 #       %addusertogroup myuser agroup
663 #
664 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
665
666 # banner support (useful in {pre,post}{,un} and triggers)
667 #
668 # Usage:
669 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
670 # the banner text, the banner text
671 # the banner text, and following line
672 #EOF
673 # You can use any form of here-document, <<'EOF' <<-EOT will do.
674 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
675 #
676 # -a   - append to the banner
677 # -e   - send to stderr instead of stdout
678 # -n   - no show banner (overrides -t)
679 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
680 %banner(aent:)  \
681 RPM_SCRIPTVERBOSITY=5 \
682 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
683 if [ -x /usr/bin/banner.sh ]; then \
684         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
685 else \
686         CMD="cat%{-e: >&2}" \
687 fi \
688 eval $CMD %2%{?3: %3} \
689 %nil
690
691 # useradd/groupadd macros
692 # Author: Elan Ruusamäe <glen@pld-linux.org>
693 #
694 # Usage:
695 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
696 #   [-g initial_group] [-G group[,...]] login
697 #
698 #  -u uid. REQUIRED
699 #  -g gid/group. REQUIRED
700 #  -s defaults to /bin/false
701 #  -d defaults to /usr/share/empty
702 #  -c No default
703 #  -r is accepted but ignored (it's always set)
704 #  -k skeleton dir. defaults to /usr/share/empty
705 # rpm specific flags
706 #  -P package name. defaults to %{name}
707 #
708 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
709 %{!-u:%{error:useradd: Required argument -u missing}} \
710 %{!-g:%{error:useradd: Required argument -g missing}} \
711 %{!?1:%{error:useradd: Required parameter login missing}} \
712 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
713         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
714                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
715                 exit 1 \
716         fi \
717 else \
718         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
719         /usr/sbin/useradd \\\
720                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
721                 -u %{-u*} \\\
722                 -r \\\
723                 -d %{-d*}%{!-d:/usr/share/empty} \\\
724                 -s %{-s*}%{!-s:/bin/false} \\\
725                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
726                 -g %{-g*} \\\
727                 %{-M} \\\
728                 %{-G:-G %{-G*}} \\\
729                 %{expand:%{%{#}}} 1>&2 || exit $? \
730         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
731 fi;
732
733 # Usage:
734 #   %groupadd [-P package] [-g gid] group
735 #
736 # -g gid. REQUIRED
737 #
738 # Sample:
739 #   %groupadd -P %{name}-base -g %{gid} %{name}
740
741 %groupadd(g:P:rfo)      \
742 %{!-g:%{error:groupadd: Required argument -g missing}} \
743 %{!?1:%{error:groupadd: Required parameter group missing}} \
744 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
745         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
746                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
747                 exit 1 \
748         fi \
749 else \
750         echo "Adding group %{1} GID=%{-g*}." \
751         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
752         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
753 fi;
754
755 # apache_config_{install/uninstall} macros *DEPRECATED*
756 # Author: Elan Ruusamäe <glen@pld-linux.org>
757 #
758 # You should use webapp macros instead. these are here until single piece of
759 # them is gone from specs ;)
760 #
761 # The config is installed/removed inside trigger, this means that you can any
762 # time install apache1 or apache package and the configuration file is updated.
763 # if you don't need the config for various reason for specific apache, just
764 # remove the symlink from apache config directory. the trigger will not put the
765 # config again to that version of apache. In other words the config is linked
766 # to apache config directory on first install of PACKAGE or apache.
767 #
768 # should be called in trigger body:
769 #  %triggerin -- apache1 >= 1.3.33-2
770 #  %apache_config_install -v 1
771 #
772 # Add package's apache config to apache config.
773 #
774 # Usage:
775 #   %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
776 #
777 #  -v REQUIRED: specify apache version. can be 1 or 2.
778 #  -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
779 #  -n OPTIONAL: specify config "slot". defaults to 99
780 #  -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
781 #
782 # Internal macros. don't use ;).
783 # expands apache config dir by apache version at build time.
784 %__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
785 # expands apache service name by apache version at build time.
786 %__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
787
788 %apache_config_install(fv:c:n:) \
789 %{!-v:%{error:apache_config_install: Required argument -v missing}} \
790 %{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
791 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
792         ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
793 fi\
794 # reload apache if the config symlink is there\
795 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
796         # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
797         if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
798                 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
799         fi\
800 fi\
801 %{nil}
802
803 # Remove package's apache config from apache config.
804 #
805 # Usage:
806 #   %apache_config_uninstall -v {1|2} -n 99
807 #
808 #  -v REQUIRED: specify apache version. can be 1 or 2.
809 #  -n OPTIONAL: specify config "slot". defaults to 99
810 %apache_config_uninstall(v:n:) \
811 %{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
812 %{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
813 # remove link if either of the packages are gone \
814 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
815         if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
816                 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
817                 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
818                         /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
819                 fi \
820         fi \
821 fi \
822 %{nil}
823
824 # webapp macros
825 # Author: Elan Ruusamäe <glen@pld-linux.org>
826 #
827 # The config is installed/removed inside trigger, this means that you can any
828 # time install apache1/apache/lighttpd package and the configuration file is
829 # updated. if you don't need the config for various reason for specific
830 # webserver, just remove the symlink from config directory using webapp
831 # program. the trigger will not recreate the symlink on upgrades. In other
832 # words the config is linked to webserver config directory on first install of
833 # PACKAGE or WEBSERVER.
834 #
835 # Add package's webserver config to webserver webapps dir.
836 # Usage:
837 #   %webapp_register WEBSERVER WEBAPP
838 #
839 %webapp_register() \
840 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
841 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
842         /usr/sbin/webapp register %1 %2\
843 fi\
844 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
845 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
846         %{expand:%service -q %%1 reload}\
847 fi\
848 %{nil}
849
850 # Remove package's config from webserver webapps dir.
851 # Usage:
852 #   %webapp_register [-f] WEBSERVER WEBAPP
853 %webapp_unregister(f) \
854 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
855 # remove link if either of the packages are gone \
856 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
857         /usr/sbin/webapp unregister %1 %2\
858         %{expand:%service -q %%1 reload}\
859 fi \
860 %{nil}
861
862 # see browser-plugins.spec / template-browser-plugin.spec
863 # Author: Elan Ruusamäe <glen@pld-linux.org>
864 %nsplugin_install(d:f) { \
865 # create link if it's first install of either of the packages \
866 if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
867 ( \
868 %( \
869         for file in %{*}; do \
870                 echo echo Installing $file to %{-d*}; \
871                 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
872         done ) \
873 ) | ( %banner -t 5 -e %{name}-in ); fi; \
874 }
875
876 %nsplugin_uninstall(d:) { \
877 # remove link if either of the packages are gone \
878 if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
879 ( \
880 %( \
881         for file in %{*}; do \
882                 echo echo Removing $file from %{-d*}; \
883                 echo "rm -f %{-d*}/$file;"; \
884         done ) \
885 ) | ( %banner -t 5 -e %{name}-un ); fi; \
886 }
887
888 # service macro.
889 # Author: Elan Ruusamäe <glen@pld-linux.org>
890 #
891 # calls usual service restart on package %post, but skips the restart if
892 # administrator has disabled automatic service restarts in either global
893 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
894 #
895 # Usage:
896 #   %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
897 #
898 #  -q be silent when service isn't started (for scriplets restaring other package's services)
899 #
900 %service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
901
902
903 # java macros. based on jpackage macros.java
904 %_jvmdir                %{_libdir}/jvm
905 %_jvmjardir             %{_libdir}/jvm-exports
906 %_jvmprivdir            %{_libdir}/jvm-private
907 %_jvmlibdir             %{_libdir}/jvm
908 %_jvmdatadir            %{_datadir}/jvm
909 %_jvmsysconfdir         %{_sysconfdir}/jvm
910 # FIXME: are these used?
911 %_jvmcommonlibdir       %{_libdir}/jvm-common
912 %_jvmcommondatadir      %{_datadir}/jvm-common
913 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
914 %_jnidir                %{_libdir}/java
915 %java_home              %(unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo $JAVA_HOME)
916
917 %ant                    JAVA_HOME=%{java_home} ant
918 %jar                    %{java_home}/bin/jar
919 %java                   %(unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
920 %javac                  %{java_home}/bin/javac
921 %javadoc                %{java_home}/bin/javadoc
922
923 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
924
925 %jpackage_script() \
926 install -d $RPM_BUILD_ROOT%{_bindir}\
927 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
928 #!/bin/sh\
929 #\
930 # %{name} script\
931 # JPackage Project <http://www.jpackage.org/>\
932 \
933 # Source functions library\
934 . %{_javadir}-utils/java-functions\
935 \
936 # Source system prefs\
937 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
938     . %{_sysconfdir}/java/%{name}.conf\
939 fi\
940 \
941 # Source user prefs\
942 if [ -f $HOME/.%{name}rc ]; then\
943     . $HOME/.%{name}rc\
944 fi\
945 \
946 # Configuration\
947 MAIN_CLASS=%1\
948 BASE_FLAGS=%2\
949 BASE_OPTIONS=%3\
950 BASE_JARS="%(echo %4 | tr ':' ' ')"\
951 \
952 # Set parameters\
953 set_jvm\
954 set_classpath $BASE_JARS\
955 set_flags $BASE_FLAGS\
956 set_options $BASE_OPTIONS\
957 \
958 # Let's start\
959 run "$@"\
960 EOF
961
962 # PEAR install macros
963 # Author: Elan Ruusamäe <glen@pld-linux.org>
964 #
965 # Usage:
966 #       %%pear_package_setup [-a #] [-n FMT]
967 #
968 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
969 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
970 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
971 #
972 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
973 # destination hierarchy. you should copy the tree to buildroot after
974 # patching/reorganizing with %%pear_package_install.
975 #
976 # additionally BUILDROOT is stripped from files and files are converted to UNIX
977 # line endings.
978 #
979 # the pear install process output is recorded to install.log, you should put it
980 # to %%doc for later debug or just for information.
981 #
982 # additionally additional-packages.txt is produced if it was detected that the
983 # package has optional dependencies. the file format is suitable of displaying
984 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
985 # automatically added for this file.
986
987
988 # records install.log and transforms PEAR names to PLD Linux rpm package names.
989 %__pear_install_log \
990 tee install.log \
991 # make post message of optional packages \
992 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
993 if [ -s optional-packages.txt ]; then \
994         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
995 else \
996         rm -f optional-packages.txt \
997 fi \
998 %{nil}
999
1000 # command invoking pear cli
1001 %__pear /usr/bin/pear
1002
1003 # the main macro.
1004 # using this macro will append optional-packages.txt to the nocompressdoc list
1005 # as it's displayed to user after package install. and adding additional gzip
1006 # dep is just waste ;)
1007 %pear_package_setup(a:n:z) \
1008 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1009 %define builddir %{_builddir}/%{srcdir} \
1010 %setup -q -c -T -n %{srcdir} \
1011 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1012 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1013 %__pear \\\
1014         -c pearrc \\\
1015         -d doc_dir=/docs \\\
1016         -d php_dir=%{php_pear_dir} \\\
1017         -d bin_dir=%{_bindir} \\\
1018         -d data_dir=%{php_pear_dir}/data \\\
1019         -d test_dir=%{php_pear_dir}/tests \\\
1020         install \\\
1021         --packagingroot=%{builddir} \\\
1022         --offline \\\
1023         --nodeps \\\
1024         %{-f:--force} \\\
1025         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; } \
1026 %{-z:cd ..} \
1027 cat %{-z:$_N/}.install.log | %__pear_install_log \
1028 \
1029 # undos sources \
1030 find . -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1031 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1032 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1033 %{nil}
1034
1035 # copies exctracted PEAR package structure to buildroot.
1036 # also copies PEAR registry file.
1037 # please use this macro, for future extensions being possible.
1038 %pear_package_install() \
1039 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1040 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1041 # help the developer out a little: \
1042 if [ -f _noautoreq ]; then \
1043         echo "AutoReqdep detected:" \
1044         echo "_noautoreq $(cat _noautoreq)" \
1045 fi \
1046 %{nil}
1047
1048
1049 # Register OpenLDAP schema.
1050 # Author: Elan Ruusamäe <glen@pld-linux.org>
1051 #
1052 # Usage:
1053 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1054 #
1055 #  -d specify dependant schemas, separated by comma
1056 #
1057 %openldap_schema_register(d:) \
1058 for schema in %*; do \
1059         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1060                 %{__sed} -i -e " \
1061                         /^include.*local.schema/{ \
1062                                 iinclude\\t     $schema\
1063                         } \
1064                 " /etc/openldap/slapd.conf \
1065         fi \
1066 done \
1067 # enable dependant schemas \
1068 if [ "%{-d*}" ]; then \
1069         %{__sed} -i -e ' \
1070         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1071                 s/^#// \
1072         }' /etc/openldap/slapd.conf \
1073 fi \
1074 %{nil}
1075
1076 # Unregister OpenLDAP schema.
1077 # Author: Elan Ruusamäe <glen@pld-linux.org>
1078 #
1079 # Usage:
1080 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1081 #
1082 %openldap_schema_unregister() \
1083 for schema in %*; do \
1084         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1085                 %{__sed} -i -e " \
1086                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1087                 # for symmetry it would be nice if we disable enabled schemas in post, \
1088                 # but we really can not do that, it would break something else. \
1089                 " /etc/openldap/slapd.conf \
1090         fi \
1091 done \
1092 %{nil}
1093
1094 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1095
1096
1097 # Build modules for kernels 2.6
1098 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1099 #
1100 # Usage:
1101 #       %build_kernel_modules -m <modules> -C <directory>
1102 #
1103 #  remember that proper Makefile is still required
1104 # Options:
1105 #  -m <modules> (required) -- comma-separated list of modules to save,
1106 #               without .ko extension, may be placed in subdirectory
1107 #  -C <directory> -- change to <directory> before doing anything
1108 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1109 #  -c -- do not execute make clean
1110 #  <additional arguments> -- all additional arguments will be passed to
1111 #               make modules
1112 #
1113 # Additional patching supported via here document. Try:
1114 #       %build_kernel_modules -m module <<'EOF'
1115 #       your patch script here
1116 #       EOF
1117 # Don't use it unless patching depends on config options.
1118
1119 # Developer note: don't touch it unless you know how to handle '\'.
1120 # - \ in script expands to nothing
1121 # - \\\ in script expands to \
1122 # - \\\ inside definition expands to noting
1123 # - \\\\\\\ inside definition expands to \
1124 # - in last line \ has to touch arguments so arguments passing
1125 #   in new lines (using \) will be supported
1126
1127 %build_kernel_modules(p:P:m:C:c)                                                                        \
1128 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1129                                                                                                                                         \
1130 %define Opts                                                                                                            \\\\\\\
1131 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1132         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1133         CC="%{__cc}" CPP="%{__cpp}" ARCH=%{_target_base_arch}                   \\\
1134         %else                                                                                                                   \\\
1135         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1136         %endif                                                                                                                  \\\
1137 %else                                                                                                                           \\\
1138         CC="%{__cc}" CPP="%{__cpp}"                                                                             \\\
1139 %endif                                                                                                                          \
1140 %define MakeOpts HOSTCC="%{__cc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1141                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1142                                                                                                                                         \
1143 %{?-C:cd %{-C*}}                                                                                                        \
1144 compile() {                                                                                                                     \
1145         L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"    \
1146         set -e -x                                                                                                               \
1147                                                                                                                                         \
1148 for cfg in %{?with_dist_kernel:%{?with_smp:smp} up}%{!?with_dist_kernel:nondist}; do \
1149         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1150                                                                                                                                         \
1151         rm -rf o                                                                                                                \
1152         install -d o/include/linux                                                                              \
1153         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1154         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1155         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1156                                                                                                                                         \
1157         set +x                                                                                                                  \
1158         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1159         set -x                                                                                                                  \
1160                                                                                                                                         \
1161         %if %{with dist_kernel}                                                                                 \
1162                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1163                         %{-p*} %{-P*}                                                                                   \\\
1164                         %{MakeOpts}                                                                                             \
1165         %else                                                                                                                   \
1166                 install -d o/include/config                                                                     \
1167                 touch o/include/config/MARKER                                                           \
1168                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1169         %endif                                                                                                                  \
1170                                                                                                                                         \
1171         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1172                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1173                 M=$PWD %{MakeOpts}}                                                                                     \
1174         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1175                 ${1+"$@"}                                                                                                       \\\
1176                 M=$PWD %{MakeOpts}                                                                                      \
1177                                                                                                                                         \
1178         for MODULE in {%{-m*},}; do                                                                             \
1179                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1180         done                                                                                                                    \
1181 done                                                                                                                            \
1182 %{?-C:cd -}                                                                                                                     \
1183 }                                                                                                                                       \
1184 compile %{*}\
1185 %{nil}
1186
1187
1188 # Install kernel modules built by %build_kernel_modules
1189 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1190 #
1191 # Usage:
1192 #       %install_kernel_modules -m <modules> -d <directory>
1193 #
1194 # Options:
1195 #  -m <modules> (required) -- comma-separated list of modules to install,
1196 #               without .ko extension, may be placed in subdirectory
1197 #  -d <directory> (required) -- in what subdirectory modules should be
1198 #               installed (eg. misc, kernel/drivers/net)
1199 #  -s <suffix> -- suffix to use when installing modules, useful when module
1200 #               with same name exists in kernel already
1201 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1202 #               for definig aliases, only useful with -s
1203
1204 %install_kernel_modules(m:d:s:n:)                                                                       \
1205 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1206 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1207 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1208                                                                                                                                         \
1209 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1210 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1211                                                                                                                                         \
1212 install -d %{KernelD}{,smp}/%{-d*}                                                                      \
1213 %{?-s:install -d %{ModprobeD}{,smp}}                                                            \
1214                                                                                                                                         \
1215 for MODULE in {%{-m*},}; do                                                                                     \
1216         [ -n "${MODULE}" ] || continue                                                                  \
1217         MNAME=${MODULE##*/}                                                                                             \
1218         install ${MODULE}-%{?with_dist_kernel:up}%{!?with_dist_kernel:nondist}.ko \\\
1219                 %{KernelD}/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                                      \
1220         %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
1221                 >> %{ModprobeD}/%{-n*}.conf}                                                            \
1222     %if %{with smp} && %{with dist_kernel}                                                      \
1223         install ${MODULE}-smp.ko                                                                                \\\
1224                 %{KernelD}smp/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                           \
1225         %{?-s:echo "alias ${MNAME} ${MNAME}-%{-s*}"                                             \\\
1226                 >> %{ModprobeD}smp/%{-n*}.conf}                                                         \
1227     %endif                                                                                                                      \
1228 done                                                                                                                            \
1229 %{nil}
1230
1231 # vim:ts=4 sw=4 noet syn=spec
This page took 0.265739 seconds and 4 git commands to generate.